$use "zlib1.lib" :' dll imports
$use "ws2_32.lib"


typedef gzFile pointer
typedef BOOL int
typedef SOCKET int
typedef DWORD UINT
typedef HWND int
typedef LPCSTR pointer
typedef LPCVOID pointer
typedef LPVOID pointer
typedef LPSTR pointer

declare cdecl import, gzopen(path:string, mode:string),gzFile
declare cdecl import, gzread(hfile:gzFile, buf:pointer, length:UINT),int
declare cdecl import, gzclose(hfile:gzFile),int
declare cdecl import, gzerror(hfile:gzFile, errnum:pointer),string

declare import,WSAStartup(wVersionRequested:word, lpWSAData:pointer),int
declare import,closesocket(s:SOCKET),int
declare import,connect(s:SOCKET, name:pointer, namelen:int),int
declare import,gethostbyname(name:pointer),pointer
declare import,inet_addr(cp:pointer),UINT
declare import,socket(af:int, _type:int, protocol:int),SOCKET 
declare import,WSACleanup(),int
declare import,htons(word hostshort),word
declare import,send(s:SOCKET, buf:pointer, _len:int, flags:int),int
declare import,recv(s:SOCKET, buf:pointer, _len:int, flags:int),int

declare import,GetFileSize(hFile:BFILE, lpFileSizeHigh:pointer),DWORD 
declare import,MessageBoxA(hWnd:HWND, lpText:LPCSTR, lpCaption:LPCSTR, uType:UINT),int
declare import,WriteFile(hFile:BFILE, lpBuffer:pointer, nNumberOfBytesToWrite:int, lpNumberOfBytesWritten:pointer, lpOverlapped:pointer),BOOL
declare import,ReadFile(hFile:BFILE, lpBuffer:pointer, nNumberOfBytesToRead:int,lpNumberOfBytesRead:pointer, lpOverlapped:pointer),BOOL
declare import,SetEndOfFile(hFile:BFILE),BOOL 
declare import,MoveFile alias MoveFileA(lpExistingFileName:pointer, lpNewFileName:pointer),BOOL
declare import,FormatMessage alias FormatMessageA(dwFlags:int, lpSource:pointer, dwMessageId:DWORD, dwLanguageId:DWORD, lpBuffer:pointer, nSize:DWORD, Arguments:pointer),DWORD
declare import,GetLastError(),DWORD
declare import,SetConsoleTextAttribute(hConsoleOutput:HANDLE, wAttributes:word),BOOL
declare import,GetStdHandle(DWORD nStdHandle),HANDLE

declare cdecl extern isdigit alias _isdigit(i:int),int
declare cdecl extern _system(c:pointer),int
declare cdecl extern memset alias _memset(a:pointer, b:int, n:int),int
declare cdecl extern strchr alias _strchr(q:pointer, w:int),pointer
declare cdecl extern memcmp alias _memcmp(a:pointer, b:pointer, n:int),int
declare cdecl extern memcpy alias _memcpy(a:pointer, b:pointer, n:int),int
declare cdecl extern strstr alias _strstr(q:pointer, w:pointer),pointer

$define AF_INET     2
$define SOCK_STREAM 1
$define IPPROTO_TCP 6
$define INVALID_SOCKET -1
$define SOCKET_ERROR -1
$define FORMAT_MESSAGE_FROM_SYSTEM     0x00001000
CONST MB_ICONSTOP = 0x10

type in_addr,1
	int S_addr[0]
	char s_b1
	char s_b2
	char s_b3
	char s_b4
endtype


type sockaddr_in
	word sin_family
	word sin_port
	in_addr sin_addr
	char sin_zero[8]
endtype

type  hostent
	pointer h_name          :' official name of host
	pointer h_aliases       :' alias list
	word h_addrtype      :' host address type
	word h_length        :' length of address
	pointer h_addr_list[0]  :' list of addresses
	pointer h_addr          :' address:, for backward compat
endtype

type sockaddr
	word sa_family              /* address family */
	char sa_data[14]            /* up to 14 bytes of direct address */
endtype

declare extern __try(),int
declare extern __leave()
declare extern __throw(any:pointer)

declare extern __catch( _
	opt ppExceptionCode = 0:pointer,  /* pointer to integer*/ _
	opt ppExceptionAddress = 0:pointer, /* pointer to integer*/ _
	opt ppExceptionDescription = 0:pointer),int /* pointer to string pointer*/

